//  T3.6_Cards Game.cpp
// Card shuffling and dealing program using structures.
#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <ctime>

using namespace std;

// Card structure definition
struct Card {
   char *face;
   char *suit;
}; // end structure Card

void fillDeck( Card * const, char *[], char *[] ); // Prototypes
void shuffle( Card * const );
void deal( Card * const );

int main()
{
   Card deck[ 52 ];
   char *face[] = { "Ace", "Deuce", "Three", "Four", 
      "Five", "Six", "Seven", "Eight", "Nine", "Ten", 
      "Jack", "Queen", "King" };
   char *suit[] = { "Hearts", "Diamonds", "Clubs", "Spades" };

   srand( time( 0 ) );  // randomize 
   
   cout << "\n\t Card shuffling and dealing program: \n\n ";
   fillDeck( deck, face, suit );
   shuffle( deck );
   deal( deck );

   system("pause");
   return 0;

} // end main

// place strings into Card structures
void fillDeck( Card * const wDeck, 
   char *wFace[], char *wSuit[] )
{
   for ( int i = 0; i < 52; i++ ) {
      wDeck[ i ].face = wFace[ i % 13 ];
      wDeck[ i ].suit = wSuit[ i / 13 ];

   } // end for

} // end function fillDeck

// shuffle cards
void shuffle( Card * const wDeck )
{
   for ( int i = 0; i < 52; i++ ) {
      int j = rand() % 52;
      Card temp = wDeck[ i ];
      wDeck[ i ] = wDeck[ j ];
      wDeck[ j ] = temp;

   } // end for

} // end function shuffle

// deal cards
void deal( Card * const wDeck )
{
   for ( int i = 0; i < 52; i++ )
      cout << right << setw( 7 ) << wDeck[ i ].face << " of " 
           << left << setw( 8 ) << wDeck[ i ].suit 
           << ( ( i + 1 ) % 2 ? '\t' : '\n' );

} // end function deal



















